library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
--
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on
--
entity cntrl_display is
port(
     clk     : in std_logic;
     reset   : in std_logic;
     pass    : in std_logic;
     display : out std_logic_vector(6 downto 0)
     );
end cntrl_display;

architecture arc_cntrl_display of cntrl_display is 

component OBUF 
	port(
	     O    :	out   STD_LOGIC;
	     I    :	in    STD_LOGIC
	     );
	end component;

signal display_buf   : std_logic_vector(6 downto 0);
signal display_n     : std_logic_vector(6 downto 0);
signal blink_cnt_tc  : std_logic;
signal blink_cnt     : std_logic_vector(25 downto 0);
signal reg_blink_cnt : std_logic_vector(25 downto 0);

begin

process(clk)
begin
     if (clk'event and clk='1') then
               if (reset='1') then
			display_buf <= "0000010";
			reg_blink_cnt <= (others => '0');
			blink_cnt <= (others => '0');
			blink_cnt_tc <= '0';
		else
			blink_cnt <= blink_cnt + 1;
			if (blink_cnt = "1111111111111111") then
				blink_cnt_tc <= '1';
				blink_cnt <= (others => '0');
			end if;

			if blink_cnt_tc = '1' then
				blink_cnt_tc <= '0';
				reg_blink_cnt <= reg_blink_cnt + "0000000001";
				if (reg_blink_cnt = "1111111111") then
					reg_blink_cnt <= (others => '0');
				end if;
			end if;
			
			if (reg_blink_cnt(9)= '1') then
				if (pass = '0') then
					display_buf <= "1110001";	-- F
				else
					display_buf <= "0110001";	-- P
				end if;

			else
				display_buf <= "1111111";	-- OFF
			end if;
		end if;
     end if;		
end process;

display_n <= not(display_buf);


	disp_pins : for i in display'range generate
		display_pin : OBUF port map(display(i), display_n(i));
	end generate;

end arc_cntrl_display;