library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
--library synplify; 
--use synplify.attributes.all; 

-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on

entity ddr1_dqs_div is
  port (
--        resetN        : in std_logic;         
        dqs           : in std_logic;  -- first column (col0) for negative edge data
        dqs1          : in std_logic;  -- second column (col1) for positive edge data
        rst_dqs_div   : in std_logic; 
        dqs_divn      : out std_logic; -- col0
        dqs_divp      : out std_logic  -- col1
       );
end ddr1_dqs_div;

architecture ddr1_dqs_div_arch of ddr1_dqs_div is

  component FDC
    port(
      Q                              :	out   STD_ULOGIC;
      C                              :	in    STD_ULOGIC;
      CLR                            :	in    STD_ULOGIC;
      D                              :	in    STD_ULOGIC     
      );
  end component;

signal dqs_div1_int  : std_logic;  
signal dqs_div0_int  : std_logic;
signal dqs_div0n     : std_logic;
signal dqs_div1n     : std_logic;
signal async_clr     : std_logic; 

begin

dqs_divn  <= dqs_div1_int;
dqs_divp  <= dqs_div0_int;
dqs_div0n <= not dqs_div0_int; 
dqs_div1n <= not dqs_div1_int;
async_clr <= rst_dqs_div;  

col1 :   FDC
    port map(
             Q   => dqs_div0_int, 
             C   => dqs1,
             CLR => async_clr,
             D   => dqs_div0n
            );

col0 :   FDC
    port map(
             Q   => dqs_div1_int, 
             C   => dqs,
             CLR => async_clr,
             D   => dqs_div1n
            );
            
end ddr1_dqs_div_arch;